import React from 'react';
import { ArrowProps, Placement } from './Overlay';
import { BsPrefixPropsWithChildren, BsPrefixRefForwardingComponent } from './helpers';
import { PopperRef } from './types';
export interface TooltipProps extends React.HTMLAttributes<HTMLDivElement>, BsPrefixPropsWithChildren {
    id: string;
    placement?: Placement;
    arrowProps?: ArrowProps;
    show?: boolean;
    popper?: PopperRef;
    hasDoneInitialMeasure?: boolean;
}
declare type Tooltip = BsPrefixRefForwardingComponent<'div', TooltipProps>;
declare const Tooltip: Tooltip;
export default Tooltip;
