import PropTypes from 'prop-types';
import React from 'react';
import { ClassNamesFnWrapper } from './createClassNames';
export interface ThemeProviderProps {
    prefixes: Record<string, string>;
    classNameMap: Record<string, string>;
    createClassNameMapper(classNameMap: Record<string, string>): ClassNamesFnWrapper;
}
declare const Consumer: React.Consumer<ThemeProviderProps>;
declare function ThemeProvider({ prefixes, classNameMap, classNameConverter, children, }: {
    prefixes: any;
    classNameMap: any;
    classNameConverter: any;
    children: any;
}): JSX.Element;
declare namespace ThemeProvider {
    var propTypes: {
        prefixes: PropTypes.Validator<object>;
        /**
         * A map of class names. The key's of the map should be
         * the Bootstrap class names used by the react-bootstrap components.
         * The value of the map record should be class name that will
         * be provided to the className attribute.
         */
        classNameMap: PropTypes.Requireable<object>;
        /**
         * Allows for a callback converter to be called on each
         * class name before it is looked up in the `classNameMap`. This
         * is to allow support for environments where the css-loader is
         * set to convert the class names to `camelCaseOnly`.
         */
        classNameConverter: PropTypes.Requireable<(...args: any[]) => any>;
    };
}
export declare function useBootstrapPrefix(prefix: string | undefined, defaultPrefix: string): string;
export declare function useClassNameMapper(localClassNameMap?: Record<string, string>): ClassNamesFnWrapper;
declare function createBootstrapComponent(Component: any, opts: any): React.ForwardRefExoticComponent<React.RefAttributes<unknown>>;
export { createBootstrapComponent, Consumer as ThemeConsumer };
export default ThemeProvider;
