import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["bsPrefix", "placement", "className", "style", "children", "arrowProps", "hasDoneInitialMeasure", "popper", "show"];
import React from 'react';
import isRequiredForA11y from 'prop-types-extra/lib/isRequiredForA11y';
import { useBootstrapPrefix, useClassNameMapper } from './ThemeProvider';
import getInitialPopperStyles from './getInitialPopperStyles';
var defaultProps = {
  placement: 'right'
};
var Tooltip = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var bsPrefix = _ref.bsPrefix,
      placement = _ref.placement,
      className = _ref.className,
      style = _ref.style,
      children = _ref.children,
      arrowProps = _ref.arrowProps,
      hasDoneInitialMeasure = _ref.hasDoneInitialMeasure,
      popper = _ref.popper,
      _ = _ref.show,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  bsPrefix = useBootstrapPrefix(bsPrefix, 'tooltip');
  var classNames = useClassNameMapper();

  var _ref2 = (placement == null ? void 0 : placement.split('-')) || [],
      primaryPlacement = _ref2[0];

  var computedStyle = style;

  if (!hasDoneInitialMeasure) {
    computedStyle = _extends({}, style, getInitialPopperStyles(popper == null ? void 0 : popper.strategy));
  }

  return /*#__PURE__*/React.createElement("div", _extends({
    ref: ref,
    style: computedStyle,
    role: "tooltip",
    "x-placement": primaryPlacement,
    className: classNames(className, bsPrefix, "bs-tooltip-" + primaryPlacement)
  }, props), /*#__PURE__*/React.createElement("div", _extends({
    className: classNames('arrow')
  }, arrowProps)), /*#__PURE__*/React.createElement("div", {
    className: classNames(bsPrefix + "-inner")
  }, children));
});
Tooltip.defaultProps = defaultProps;
Tooltip.displayName = 'Tooltip';
export default Tooltip;